/*
 * GuestBook CGI   
 * 
 */

#include "gbook.h"

//#define AUTOCONV    "/usr/bin/iconv -f big5 -t gb2312"
//#define GBAUTOCONV    "/usr/bin/iconv -f gb2312 -t big5"

#define AUTOCONV    "/usr/bin/autob5 -i big5 -o gb"
#define GBAUTOCONV    "/usr/bin/autob5 -i gb -o big5"
/* Constants */
#define GBOOK_LIST "list"
#define GBOOK_READ "read"
#define GBOOK_EDIT "edit"
#define GBOOK_POST "post"
#define GBOOK_ADMIN "admin"
#define GBOOK_DELETE "delete"
#define GBOOK_SETUP "setup"
#define GBOOK_SEARCH "search"
#define GBOOK_ATTACH "attach"

/** Template files ***/
#define LIST_FILE "glist"
#define READ_FILE "gread"
#define EDIT_FILE "gedit"
#define ADMIN_FILE "gadmin"
#define char_lower(c)  ((c >= 'A' && c <= 'Z') ? c|32 : c)

FILE *MOUT;
/* Global Variables */
char		home_path[80], talk_path[80], gbook_path[80];
char		fdir[80], gbook_conf[80],title[80],proc[32];
char		user[32],msgbuf[80], linebuf[512], msgsubj[80], msgbody[MAX_MSG_SIZE];
int             bid;
time_t		now;
struct msgDIR	msgdir;
struct stat	st;
struct passwd  *pw;
char password[17];
char rowcolor[2][16]={"",""};
char mainconf[CONFNUM][128];//޲z̥Ϊݩ
int reply=0,msgno=0;
char att_type[][6]={"jpg","png","gif","bmp","doc","ppt","mp3","rm","ram","zip","wav",
"xls","sxw","sxc","sxd","sxi","sxg","sxm",""};
char mime_type[][40]={"image/jpeg","image/png","image/gif","image/bmp","application/msword",
	"application/vnd.ms-powerpoint","audio/mpeg","audio/x-pn-realaudio","audio/x-pn-realaudio",
	"application/zip","audio/x-wav",
	"application/vnd.ms-excel","application/vnd.sun.xml.writer",
	"application/vnd.sun.xml.calc","application/vnd.sun.xml.draw",
	"application/vnd.sun.xml.impress","application/vnd.sun.xml.writer.global",
	"application/vnd.sun.xml.math",
""};

/* ---------------------------- */
/* new/old/lock file processing */
/* ---------------------------- */

typedef struct
{
  char newfn[128];
  char oldfn[128];
  char lockfn[128];
}      nol;


int cgiError(char *errmsg)
{
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
	fprintf(MOUT, "<html><head><title>CGI Error</title></head><body>");
	fprintf(MOUT, "<h2>CGI Error</h2><hr />");
	fprintf(MOUT, "<h3>%s</h3>", errmsg);
	fprintf(MOUT, "</body></html>");

	return 0;
}
void str_lower(char *t)
{
  char ch;
	    do
	      {
	          ch = *t;
		      *t++ = char_lower(ch);
	        } while (ch);
}


int cgiBP(char *msg)
{
	cgiError(msg);
	exit(1);
	return 0;
}
int tranbig5(char *str)
 {
   char genbuf[512],*pt,*pt1,buf[512];
   size_t inbytesleft, outbytesleft;
   int len;
   iconv_t ifp;
   inbytesleft=strlen(str);
   len=strlen(str);
   pt=genbuf;
   pt1=str;
   outbytesleft=sizeof(genbuf);
   ifp=iconv_open("big5","gb2312");
   if ((iconv_t) (-1) == ifp) {
    cgiError("Error at iconv_open");
    exit(1);
   }
   if (iconv(ifp,&pt1,&inbytesleft,&pt,&outbytesleft)==-1)
   {
    cgiError("Error at iconv");
    exit(1);
   }
   iconv_close(ifp);
   strncpy(str,genbuf,len);
   return 0;
 }
int gbook_list();
int gbook_search();
int gbook_edit();
int gbook_post();
int gbook_read();
int gbook_admin();
int gbook_delete();
int gbook_setup();
int g_list(int mode);
int g_search(int mode);
int g_edit();
int g_read();
int g_admin();
int SSI(int ptmode);
int showout(char *filename);
int delete_record(char *fpath, int size, int id);
int is_file(char *filename,char *key);
int gbook_attach();
int htmlrep(char *genbuf);
void imgrep(char *genbuf);
	
/*
 *---------------------------------------------------------------------
 * Guestbook: Main Program
 *---------------------------------------------------------------------
 */

int cgiMain()
{
	char  server[80], buf[32],genbuf[64];
	FILE	*fp;
	int len,i;
#ifdef GBCODE
	MOUT=popen(AUTOCONV,"w");
	if (MOUT==NULL) cgiError("autoconvert open error");
#else
	MOUT=cgiOut;
#endif
	if (cgiFormString("user", user, 32) != cgiFormSuccess) {
		if (strlen(cgiQueryString) > 0) {
			strncpy(user, cgiQueryString, 32);
		} else {
			if (cgiServerName) {
				strncpy(server, cgiServerName, 80);
			} else {
				strncpy(server, "your_cgi_server", 80);
			}
			sprintf(msgbuf, "gbook usage: http://%s%s?someone's_account_name&amp;bid=board_id", server,CGI_SCRIPT);
			cgiError(msgbuf);
			exit(1);
		}
	}

	/* initialization */
	if ((pw = getpwnam(user)) != NULL) {
		strncpy(home_path, pw->pw_dir, 80);
	} else {
		sprintf(msgbuf, "Can not find user %s on this host", user);
		cgiError(msgbuf);
		exit(1); 
	}
	if (cgiFormInteger("bid", &bid, 0) == cgiFormSuccess) {
                if (bid > 0) {
                        sprintf(gbook_path, "%s/%s%d", home_path, GBOOK_DIR, bid);
                } else {
                        sprintf(gbook_path, "%s/%s", home_path, GBOOK_DIR);
                }
        } else {
                sprintf(gbook_path, "%s/%s", home_path, GBOOK_DIR);

        }


	sprintf(talk_path, "%s/%s", gbook_path, TALK_DIR);
	sprintf(fdir, "%s/%s", talk_path, MSGDIR_RECORD);
	sprintf(gbook_conf, "%s/%s", gbook_path, GBOOK_CONF);

	/* get the title of guestbook */
	if ((fp = fopen(gbook_conf, "r")) != NULL) {
		fgets(title, 80, fp); //D
		fgets(buf, 32, fp);  //MPP 
		fgets(password, 16, fp);//KX
		if (fgets(genbuf, 64, fp)!=NULL)//wC@
		{
		   if (strchr(genbuf,'=')!=NULL || strchr(genbuf,'&')!=NULL)
    		   {
        	    cgiError("<h2>AObȶܡH!CⳡD</h2>");
			exit(1);
		   }
		  len = strlen(genbuf);
		  while (len > 0) {
			if ((genbuf[len - 1] == '\n')||(genbuf[len - 1] == ' ')
			||(genbuf[len - 1] == '\r')||(genbuf[len - 1] == '\t'))
			 {
				genbuf[len - 1] = '\0';
				len--;
			}
			else break;
		  } //while len
		  if (len)
		    strcpy(rowcolor[0],genbuf);
		  else 
		    strcpy(rowcolor[0],ARRCOLOR1);
		}
		else strcpy(rowcolor[0],ARRCOLOR1);
		if (fgets(genbuf, 64, fp)!=NULL)//wCG
		{
		   if (strchr(genbuf,'=')!=NULL || strchr(genbuf,'&')!=NULL)
    		   {
        	    cgiError("<h2>AObȶܡH!CⳡD</h2>");
		    exit(1);
		   }
		  len = strlen(genbuf);
		  while (len > 0) {
			if ((genbuf[len - 1] == '\n')||(genbuf[len - 1] == ' ')
			||(genbuf[len - 1] == '\r')||(genbuf[len - 1] == '\t'))
			 {
				genbuf[len - 1] = '\0';
				len--;
			}
			else break;
		  } //while len
		  if (len)
		    strcpy(rowcolor[1],genbuf);
		  else 
		    strcpy(rowcolor[1],ARRCOLOR2);
		}
		else strcpy(rowcolor[1],ARRCOLOR2);
		for (i=0;i<CONFNUM;i++)
		{
		   if (fgets(mainconf[i], 128, fp)==NULL)
		       mainconf[i][0]=0;
		   else
		   {
		    if (strchr(mainconf[i],'=')!=NULL 
  		    || strchr(mainconf[i],'&')!=NULL)
    		    {
        	      cgiError("<h2>AObȶܡH!ݩʳD</h2>");
		      exit(1);
		    }
		      len = strlen(mainconf[i]);
		      while (len > 0) 
			if ((mainconf[i][len - 1] == '\n')
			||(mainconf[i][len - 1] == ' ')
			||(mainconf[i][len - 1] == '\r')
			||(mainconf[i][len - 1] == '\t'))
			 {
				mainconf[i][len - 1] = '\0';
				len--;
			}
			else break;
  		   } //NULL
		}

		fclose(fp);
		len = strlen(title);
		if (len > 0) {
			if (title[len - 1] == '\n') {
				title[len - 1] = '\0';
			}
		} else {
			strncpy(title, user, 80);
		}
		MPP=atoi(buf);
		if ((MPP<1) || (MPP>50)) MPP=20;
		len = strlen(password);
		if (len > 0) {
                        if (password[len - 1] == '\n') {
                                password[len - 1] = '\0';
                        }
                } else {
                        strcpy(password, "KMUfhl");
                }
	} else { /* default title is user name */
		strncpy(title, user, 80);
	}

	if (cgiFormString("proc", proc, 16) != cgiFormSuccess) {
	   	strcpy(proc,"list");
		gbook_list();
		return 0;
	}

	if (strncmp(proc, GBOOK_LIST, 40) == 0) {
		gbook_list();
	} else if (strncmp(proc, GBOOK_READ, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_read();
	} else if (strncmp(proc, GBOOK_EDIT, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_edit();
	} else if (strncmp(proc, GBOOK_POST, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_post();
    } else if (strncmp(proc, GBOOK_ADMIN, 40) == 0) {
		gbook_admin();
	} else if (strncmp(proc, GBOOK_DELETE, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_delete();
	} else if (strncmp(proc, GBOOK_SETUP, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_setup();
	} else if (strncmp(proc, GBOOK_SEARCH, 40) == 0) {
	   	strcpy(proc,"search");
		gbook_search();
	} else if (strncmp(proc, GBOOK_ATTACH, 40) == 0) {
	   	strcpy(proc,"list");
		gbook_attach();
	} else {
		sprintf(msgbuf, "CGI gbook has no such function: %s", proc);
		cgiError(msgbuf);
		exit(1);
	}


#ifdef GBCODE
	pclose(MOUT);
#endif
	return 0;
}
/*
 *---------------------------------------------------------------------
 *	Guestbook: Show Attach
 *---------------------------------------------------------------------
 */
int gbook_attach()
{
	 char genbuf[4096],location[128],fn[80];
	 FILE *fp;
	 int i,atype;
	 struct stat sb;

	if (cgiFormString("file", fn, 80) != cgiFormSuccess) {
		                             fn[0] = '\0';
                }
	 if (cgiFormInteger("atype", &atype, 0) != cgiFormSuccess) {
		 cgiError("Error! on atype!");
	 }
          sprintf(location,"%s/%s.%s",talk_path,fn,att_type[atype]);
	  if (!lstat(location, &sb)) {
	   	if ((sb.st_mode & 0777000) != S_IFREG) {
			cgiHeaderContentType("text/html");
			  fprintf(MOUT,"error: %s O@LinkIKKI\n",location);
			  return (1);
	        }
	  }
   	  else
   	  {
		cgiHeaderContentType("text/html");
               fprintf(MOUT,"error: %s stat error!\n",location);
                                return (1);
   	  }
	   //cgiError(location);
           cgiHeaderContentType(mime_type[atype]);
           if ((fp = fopen(location, "r"))!=NULL)
            {
                     while ((i=fread(genbuf,1,4096, fp))>0)
                     fwrite(genbuf,1,i,cgiOut);
                    fclose(fp);
             } else
           {
              fprintf(MOUT,"S%sɮ",location);
           }
	   return 0;
}
/*
 *---------------------------------------------------------------------
 *	Guestbook: Setup
 *---------------------------------------------------------------------
 */
int gbook_setup()
{
 char buf[17],genbuf[128];
 char newtitle[80],newpwd1[17],newpwd2[17],newcolor1[64],newcolor2[64];
 int newMPP,i,len;
 FILE *fp;
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
    cgiFormStringNoNewlines("password",buf,16);
        if (strcmp(password,buf)) {
                fprintf(MOUT,"<h2>KX~I</h2>");
	fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;proc=admin&amp;bid=%d\">ЫB^޲ze</a></center>", CGI_SCRIPT, user,bid);
                return 0;
        }
    /****** Ѽ *******/
    cgiFormStringNoNewlines("newpass1",newpwd1,16);
    cgiFormStringNoNewlines("newpass2",newpwd2,16);
        if (strcmp(newpwd1,newpwd2)) {
                fprintf(MOUT,"<h2>sKX@P!</h2>");
	fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;proc=admin&amp;bid=%d\">ЫB^޲ze</a></center>", CGI_SCRIPT, user,bid);
                return 0;
        }
	if (newpwd1[0]==0)
            strcpy(newpwd1,password);
    cgiFormStringNoNewlines("newTITLE",newtitle,79);
	if (newtitle[0]==0)
            strcpy(newtitle,title);
    cgiFormInteger("newMPP", &newMPP, 0);
	if (newMPP==0) newMPP=MPP;
    if ((MPP<1) || (MPP>50)) 
    	{MPP=20;
	 fprintf(MOUT,"<h2>CgƳ]wȤb1P50AN]w20I</h2>");
	}
     /**** color ******/
    cgiFormStringNoNewlines("newcolor1",newcolor1,60);
    cgiFormStringNoNewlines("newcolor2",newcolor2,60);
    /*****ˬd@Ucolor ********/
    if (strchr(newcolor1,'=')!=NULL || strchr(newcolor1,'&')!=NULL
	||strchr(newcolor2,'=')!=NULL || strchr(newcolor2,'&')!=NULL)
    {
        fprintf(MOUT,"<h2>AObȶܡH!</h2>");
	fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;proc=admin&amp;bid=%d\">ЫB^޲ze</a></center>", CGI_SCRIPT, user,bid);
                return 0;
    }
      /****ˬdcolorO_ť****/
    len = strlen(newcolor1);
    while (len > 0) 
    if ((newcolor1[len - 1] == '\n')||(newcolor1[len - 1] == ' ')
        ||(newcolor1[len - 1] == '\r')||(newcolor1[len - 1] == '\t'))
      {
          newcolor1[len - 1] = '\0';
          len--;
      }
     else break;
     if (len==0) strcpy(newcolor1,rowcolor[0]);
    len = strlen(newcolor2);
    while (len > 0) 
    if ((newcolor2[len - 1] == '\n')||(newcolor2[len - 1] == ' ')
        ||(newcolor2[len - 1] == '\r')||(newcolor2[len - 1] == '\t'))
      {
          newcolor2[len - 1] = '\0';
          len--;
      }
     else break;
     if (len==0) strcpy(newcolor2,rowcolor[1]);

    /***** arrtibute *****/
    for (i=0;i<CONFNUM;i++)
    {
	sprintf(buf,"ATT%d",i+1);
	cgiFormStringNoNewlines(buf,genbuf,127);
	/*****Bz@Uattribute ****/
	 if (strchr(genbuf,'=')!=NULL || strchr(genbuf,'&')!=NULL)
         {
           fprintf(MOUT,"<h2>AObȶܡH!</h2>");
            fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;proc=admin&amp;bid=%d\">ЫB^޲ze</a></center>", CGI_SCRIPT, user,bid);
                return 0;
        }
      /****ˬdѼƬO_ť****/
        len = strlen(genbuf);
        while (len > 0)
        if ((genbuf[len - 1] == '\n')||(genbuf[len - 1] == ' ')
          ||(genbuf[len - 1] == '\r')||(genbuf[len - 1] == '\t'))
        {
          genbuf[len - 1] = '\0';
          len--;
        }
        else break;
        if (len) strcpy(mainconf[i],genbuf);

    }
	/* get the title of guestbook */
       if ((fp = fopen(gbook_conf, "w")) != NULL) {
	fprintf(fp,"%s\n%d\n%s\n%s\n%s\n",newtitle,newMPP,newpwd1
					,newcolor1,newcolor2);
        for (i=0;i<CONFNUM;i++)
        {
	    fprintf(fp,"%s\n",mainconf[i]);
        }
	fclose(fp);
	}
	else{
              fprintf(MOUT,"<h2>%sɮ׶}ҿ~I</h2>",gbook_conf);
	fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;proc=admin&amp;bid=%d\">ЫB^޲ze</a></center>", CGI_SCRIPT, user, bid);
                return 0;
        }
	fprintf(MOUT,"ק粒<br />\n");
	fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;proc=admin&amp;bid=%d\">ЫB^޲ze</a></center>", CGI_SCRIPT, user,bid);
	return 0;
}
/*
 *---------------------------------------------------------------------
 *	Guestbook: Admin
 *---------------------------------------------------------------------
 */
int gbook_admin()
{
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
    showout(ADMIN_FILE);
    return 0;
}
int g_admin(int mode)
{
	char	date[40],linebuf[512];
	int	msg1no, npost, fd, i,j;
	
		
	/* get the total number of messages */
	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	/* get the No. of the first message if given */
	cgiFormInteger("msgno", &msg1no, npost);

	if (msg1no > npost || msg1no <= 0) {
		msg1no = 1;
	}

	if (npost > 0) {
		if ((fd = open(fdir, O_RDONLY)) != -1) {
		    j=1;
				if (mode==0)
				{
		    			fprintf(MOUT,"<form method=\"post\" action=\"%s\">"
		    			"<input type=\"hidden\" name=\"user\" value=\"%s\" />"
		    			"<input type=\"hidden\" name=\"proc\" value=\"delete\" />"
	            			"<input type=\"hidden\" name=\"bid\" value=\"%d\" />",CGI_SCRIPT,user,bid);
				}
			for (i = msg1no; i >= 1 && i > (msg1no - MPP); i--) {
			lseek(fd, sizeof(struct msgDIR) * (i - 1), SEEK_SET);
				read(fd, &msgdir, sizeof(msgdir));
				strncpy(date, ctime(&msgdir.ptime) + 4, 6);
				date[6] = '\0';
				//FOR HACKER
                                strcpy(linebuf,msgdir.owner);
                                htmlrep(linebuf);
				fprintf(MOUT, "<tr bgcolor=\"%s\"><td align=\"left\">", rowcolor[i%2]);
				fprintf(MOUT, "<input name=\"m%d\" type=\"checkbox\" value=\"%d\" /></td>"
			"<td  align=\"center\">%d</td><td align=\"left\">%s</td><td align=\"left\">%s</td>", 
				j++,i,i, date, linebuf);
				//FOR HACKER
                                strcpy(linebuf,msgdir.subj);
                                htmlrep(linebuf);
				fprintf(MOUT, "<td align=\"left\"><a href=\"%s?user=%s&amp;proc=read&amp;bid=%d&amp;msgno=%d\">%s</a></td></tr>\n", 
				CGI_SCRIPT, user, bid,i, linebuf);
			}
			close(fd);
		}
		fprintf(MOUT, "</table>");
		fprintf(MOUT,"<p />пJ޲zKXG<input type=\"password\" name=\"password\" size=\"17\" />");
		fprintf(MOUT,"<input type=\"submit\" name=\"S2\" value=\"R峹\" /></form>");
	//	fprintf(MOUT, "</font>");
	} else {
		fprintf(MOUT, "<p />&nbsp;<h3>|Hd</h3><p />&nbsp;");
	}

	return 0;
}

int gbook_delete()
{
	int i,killnum;
	char buf[17],chk[6];

#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
	cgiFormStringNoNewlines("password",buf,16); 
	if (strcmp(password,buf)) {
                fprintf(MOUT,"<h2>KX~I</h2>");
	fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;proc=admin&amp;bid=%d\">ЫB^޲ze</a></center>", CGI_SCRIPT, user, bid);
		return 0;
 	}

	/*** Ѽ ****/
	for (i = 1;i <= MPP; i++) {
		sprintf(buf,"m%d", i);
		cgiFormStringNoNewlines(buf,chk,5); 
    		killnum = atoi(chk);
    		//fprintf(cgiOut,"%d chk=%s killnum=%d||",i,chk,killnum);
    		if (killnum) {
            		delete_record(fdir, sizeof(struct msgDIR), killnum);
            		fprintf(MOUT,"%dg峹<br />\n",killnum);
      		}
	}
	fprintf(MOUT, "<td><a href=\"%s?user=%s&amp;proc=admin&amp;bid=%d\">ЫB^޲ze</a></tr>", 
	CGI_SCRIPT, user,bid);
    
	return 0;
}

/*
 *---------------------------------------------------------------------
 *	Guestbook:  Search
 *---------------------------------------------------------------------
 */
int gbook_search()
{
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
    showout(LIST_FILE);
    return 0;
}
int g_search(int mode)
{
	char	date[40];
	int	msg1no, npost, fd, i,founded=0;
	char    skey[128];
	
		
	/* get the total number of messages */
	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	/* get the No. of the first message if given */
	cgiFormInteger("msgno", &msg1no, npost);
	/*** get search key ****/
	cgiFormString("key", skey,127);
#ifdef GBCODE   
	        tranbig5(skey); 
#endif
	msg1no = npost;

	if (npost > 0) {
		/* show the list for messages */
		//fprintf(cgiOut, "<font size=4><table>");
		if ((fd = open(fdir, O_RDONLY)) != -1) {
			/*** don't process page ****/
			for (i = msg1no; i >= 1; i--) {
			lseek(fd, sizeof(struct msgDIR) * (i - 1), SEEK_SET);
				read(fd, &msgdir, sizeof(msgdir));
				strncpy(date, ctime(&msgdir.ptime) + 4, 6);
				date[6] = '\0';
				/****jMT~showX pݥ˯AХ[o****/
				if ((strstr(msgdir.owner,skey))
				   ||(is_file(msgdir.fn,skey))
				   ||(strstr(msgdir.subj,skey)))
				{
	
			 if (mode==2)
			 {
				//FOR HACKER
				strcpy(linebuf,msgdir.owner);
                		htmlrep(linebuf);
				fprintf(MOUT, "<tr bgcolor=\"%s\"><td align=\"center\">%d</td><td align=\"center\">%d</td><td align=\"center\">%s</td><td align=\"left\">%s</td>", rowcolor[i%2],i, msgdir.item[9],date, linebuf);
				//for hacker
				strcpy(linebuf,msgdir.subj);
                                htmlrep(linebuf);
				fprintf(MOUT, "<td align=\"left\"><a href=\"%s?user=%s&amp;proc=read&amp;bid=%d&amp;msgno=%d\">%s</a></td></tr>", 
				CGI_SCRIPT, user, bid,i, linebuf);
			 }
			 else if (mode==0)
			 {
				//FOR HACKER
				strcpy(linebuf,msgdir.owner);
                		htmlrep(linebuf);
				fprintf(MOUT, "<tr bgcolor=\"%s\"><td  align=center>%d</td><td align=\"left\">%s</td><td align=\"left\">%s</td>", rowcolor[i%2],i, date, linebuf);
				//for hacker
				strcpy(linebuf,msgdir.subj);
                                htmlrep(linebuf);
				fprintf(MOUT, "<td align=\"left\"><a href=\"%s?user=%s&amp;proc=read&amp;bid=%d&amp;msgno=%d\">%s</a></td></tr>", 
				CGI_SCRIPT, user, bid,i,i, linebuf);
			 }
			 else //eshow X
				if (mode ==1)
			  {
				//FOR HACKER
				strcpy(linebuf,msgdir.owner);
                		htmlrep(linebuf);
				fprintf(MOUT, "<tr bgcolor=\"%s\"><td  align=center>%d</td><td align=\"left\">%s</td><td align=\"left\">@̡G%s</td>", rowcolor[1],i, date, linebuf);
				//for hacker
				strcpy(linebuf,msgdir.subj);
                                htmlrep(linebuf);
				fprintf(MOUT, "<td align=\"left\">%s</a></td></tr>\n", linebuf);
				fprintf(MOUT, "<tr  bgcolor=\"%s\"><td colspan=\"4\">",rowcolor[0]);
				SSI(6);
				fprintf(MOUT, "</td></tr>\n");
			  }
				   founded++;
				}
			}
			close(fd);
		}
		fprintf(MOUT, "</table>");
		//fprintf(MOUT, "</font>");
		if (founded==0)
			fprintf(MOUT, "<p />&nbsp;<h3>S%sI</h3><p />&nbsp;",skey);
	} else {
		fprintf(MOUT, "<p />&nbsp;<h3>|Hd</h3><p />&nbsp;");
	}

	return 0;
}
/*
 *---------------------------------------------------------------------
 *	Guestbook: List 
 *---------------------------------------------------------------------
 */
int gbook_list()
{
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
    showout(LIST_FILE);
    return 0;
}

int g_list(int mode)
{
	char	date[40],linebuf[512],linebufe[128];
	int	msg1no, npost, fd, i;
	
#ifdef RREADONLY
	char buf[20];
	cgiFormStringNoNewlines("password",buf,16);
        if (strcmp(password,buf)) {
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
                fprintf(MOUT,"<h2>KX~I</h2>");
        fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;bid=%d&amp;proc=list\">ЫB^De</a></center>", CGI_SCRIPT, user,bid);
                return 0;
        }

#endif
		
	/* get the total number of messages */
	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	/* get the No. of the first message if given */
	cgiFormInteger("msgno", &msg1no, npost);

	if (msg1no > npost || msg1no <= 0) {
		msg1no = 1;
	}

	if (npost > 0) {
		/* show the list for messages */
		//fprintf(cgiOut, "<font size=4><table>");
		if ((fd = open(fdir, O_RDONLY)) != -1) {
			//for (i = msg1no; i <= npost && i < (msg1no + MPP); i++) {
			for (i = msg1no; i >= 1 && i > (msg1no - MPP); i--) {
			  lseek(fd, sizeof(struct msgDIR) * (i - 1), SEEK_SET);
			  read(fd, &msgdir, sizeof(msgdir));
			  strncpy(date, ctime(&msgdir.ptime) + 4, 6);
			  date[6] = '\0';
			 if (mode==2)
			 {
				//FOR HACKER
				strcpy(linebuf,msgdir.owner);
                		htmlrep(linebuf);
				fprintf(MOUT, "<tr bgcolor=\"%s\"><td align=\"center\">%d</td><td align=\"center\">%d</td><td align=\"center\">%s</td><td align=\"left\">%s</td>", rowcolor[i%2],i, msgdir.item[9],date, linebuf);
				//for hacker
				strcpy(linebuf,msgdir.subj);
                                htmlrep(linebuf);
				fprintf(MOUT, "<td align=\"left\"><a href=\"%s?user=%s&amp;proc=read&amp;bid=%d&amp;msgno=%d\">%s</a></td></tr>\n", 
				CGI_SCRIPT, user, bid,i,linebuf);
			 }
			 else if (mode==0)
			 {
				//FOR HACKER
				strcpy(linebuf,msgdir.owner);
                		htmlrep(linebuf);
				fprintf(MOUT, "<tr bgcolor=\"%s\"><td align=\"center\">%d</td><td align=\"center\">%s</td><td align=\"left\">%s</td>", rowcolor[i%2],i,date, linebuf);
				//for hacker
				strcpy(linebuf,msgdir.subj);
                                htmlrep(linebuf);
				fprintf(MOUT, "<td align=\"left\"><a href=\"%s?user=%s&amp;proc=read&amp;bid=%d&amp;msgno=%d\">%s</a></td></tr>\n", 
				CGI_SCRIPT, user, bid,i, linebuf);
			 }
			 else //eshow X
			    if (mode==1)
			  {
				//FOR HACKER
				strcpy(linebuf,msgdir.owner);
                		htmlrep(linebuf);
				strcpy(linebufe,msgdir.email);
                		htmlrep(linebufe);
				fprintf(MOUT, "<tr bgcolor=\"%s\"><td align=\"center\">%d</td><td align=\"center\">%s</td><td align=\"left\">@̡G<a href=\"mailto:%s\">%s</a>", rowcolor[1],i, date, linebufe,linebuf);
				strcpy(linebuf,msgdir.url);
                		htmlrep(linebuf);
				fprintf(MOUT, " }G<a href=\"%s\">%s</a></td>\n", linebuf,linebuf);
				//for hacker
				strcpy(linebuf,msgdir.subj);
                                htmlrep(linebuf);
				fprintf(MOUT, "<td align=\"left\">%s</a></td></tr>", linebuf);
				fprintf(MOUT, "<tr  bgcolor=\"%s\"><td colspan=\"4\">",rowcolor[0]);
				SSI(6);
				fprintf(MOUT, "</td></tr>");
			  }
			}
			close(fd);
		}
		fprintf(MOUT, "</table>");
		//fprintf(MOUT, "</font>");
	} else {
		fprintf(MOUT, "<p />&nbsp;<h3>|Hd</h3><p />&nbsp;");
	}

	return 0;
}

/*
 *---------------------------------------------------------------------
 *	Guestbook: Edit
 *---------------------------------------------------------------------
 */

  
int gbook_edit()
{
	FILE	*fp;
	char	type_str[40], title[80], msgfn[80];
	int	npost, fd ;

	/* reply or new */
	cgiFormString("type", type_str, 80);
	if (strncmp(type_str, "reply", 80) == 0) {
		strncpy(title, "^峹", 80);
		reply = 1;
	} else {
		strncpy(title, "o峹", 80);
	}

	/* initialization */
	msgsubj[0] = '\0';
	msgbody[0] = '\0';

	
	if (reply) {
		if (stat(fdir, &st) >= 0) {
			npost = st.st_size / (sizeof(struct msgDIR));
		} else {
			npost = 0;
		}
		if (npost > MAX_MSG_NO)
			cgiError("Too many articles, call manager to delete articles");

		if (cgiFormIntegerBounded("msgno", &msgno, 1, npost, npost) != cgiFormSuccess) {
			cgiError("relpy without message No.");
			exit(1);
		}

		if ((fd = open(fdir, O_RDONLY)) != -1) {
			lseek(fd, sizeof(msgdir) * (msgno - 1), SEEK_SET);
			read(fd, &msgdir, sizeof(msgdir));
			close(fd);
		} else {
			sprintf(msgbuf, "open file: %s failed", fdir);
			cgiError(msgbuf);
			exit(1);
		}

		if (strncmp(msgdir.subj, "^G", 6) == 0) {
			strncpy(msgsubj, msgdir.subj, 80);
		} else {
			sprintf(msgsubj, "^G%s", msgdir.subj);
		}

		sprintf(msgbody, " ޭzm%snʨG\n", msgdir.owner);
		sprintf(msgfn, "%s/%s", talk_path, msgdir.fn);
		if ((fp = fopen(msgfn, "r")) != NULL) {
			while (fgets(linebuf + 2, 500, fp) != NULL) {
				linebuf[0] = ':';
				linebuf[1] = ' ';
				if ((linebuf[2]=='-')&&(linebuf[2]=='-')) break;
				if (strlen(linebuf + 2) > 3) {
					strcat(msgbody, linebuf);
				}
			}
			fclose(fp);
		} else {
			sprintf(msgbuf, "Can not open file: %s to read", msgfn);
			cgiError(msgbuf);
			exit(1);
		}
	}
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
    showout(EDIT_FILE);
	return 0;
}

/*
 *---------------------------------------------------------------------
 *	Guestbook: post 
 *---------------------------------------------------------------------
 */

int gbook_post()
{
	char	name[40], email[80], homepage[80];
	char	msgfn[180], msgsubj[80], msgbody[MAX_MSG_SIZE];
	char genbuf[20];
	int	fd, npost, msgno=0, i;
	FILE	*fp,*fp1;
	cgiFilePtr fptr; 
	char uploadfn[180],upload_name[32],upload_orig[128],*pt;
	char filebody[4096];//4k ONCE
	int sizeP;
	char buf[20];
	now = time(0);

#ifdef READONLY
	cgiFormStringNoNewlines("password",buf,16);
        if (strcmp(password,buf)) {
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
                fprintf(MOUT,"<h2>KX~I</h2>");
        fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;bid=%d&amp;proc=list\">ЫB^De</a></center>", CGI_SCRIPT, user,bid);
                return 0;
        }

#endif
#ifdef RREADONLY
	cgiFormStringNoNewlines("password",buf,16);
        if (strcmp(password,buf)) {
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
                fprintf(MOUT,"<h2>KX~I</h2>");
        fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;bid=%d&amp;proc=list\"> ЫB^De</a></center>", CGI_SCRIPT, user,bid);
                return 0;
        }
	else
        {
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
                fprintf(MOUT,"<h2>KX!!!~I</h2>");
                return 0;
        }

#endif
	if (cgiFormString("name", name, 40) != cgiFormSuccess) {
		cgiError("Please tell us who you are");
		exit(1);
	}

	if (cgiFormString("email", email, 80) != cgiFormSuccess) {
		email[0] = '\0';
	}

	if (cgiFormString("homepage", homepage, 80) != cgiFormSuccess) {
		homepage[0] = '\0';
	}

	if (cgiFormString("msgsubj", msgsubj, 80) != cgiFormSuccess) {
		cgiError("Please give the subject for this messages");
		exit(1);
	}

	if (cgiFormString("msgbody", msgbody, MAX_MSG_SIZE) != cgiFormSuccess) {
		cgiError("Message Body is empty");
		exit(1);
	}
        /*************Lor ***********************/
	if (strstr(msgbody,"|")&&strstr(msgbody,"j"))
        {
		cgiError("Please Don't Post that, Thanks! We don't want to know that!");
		exit(1);
        }
	
#ifdef GBCODE
	tranbig5(name);
	tranbig5(msgsubj);
	tranbig5(homepage);
	tranbig5(email);
#endif
	strncpy(msgdir.owner, name, 40);
	strncpy(msgdir.subj, msgsubj, 80);
	strncpy(msgdir.host,cgiRemoteHost,40);
    	if (msgdir.host[0]==0)
      		strncpy(msgdir.host,cgiRemoteAddr,40);
	msgdir.host[39]=0;
	sprintf(msgdir.fn, "M.%d.A", (int) now);
#ifdef GBCODE
	sprintf(msgfn, GBAUTOCONV " > %s/M.%d.A", talk_path, (int) now);
#else
	sprintf(msgfn, "%s/M.%d.A", talk_path, (int) now);
#endif
	msgdir.ptime = now;
	strcpy(msgdir.url,homepage);
	strcpy(msgdir.email,email);
	for (i=0;i<=8;i++) //9d@H\
	{
	    sprintf(genbuf,"O%d",i+1);
	    if (cgiFormInteger(genbuf, &(msgdir.item[i]), 0)  != cgiFormSuccess) {
	        msgdir.item[i]=0;
	    }
	}

	if ((fd = open(fdir, O_RDWR | O_CREAT, 0666)) == -1) {
		sprintf(msgbuf, "Can not open file: %s", fdir);
		cgiError(msgbuf);
		exit(1);
	}

	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}
	if (npost > MAX_MSG_NO)
			cgiError("Too many articles, call manager to delete articles");

	if ((msgno < 0) || (msgno > npost)) {
		cgiError("msgno is over range");
		exit(1);
	}

	if (lseek(fd, sizeof(struct msgDIR) * npost, SEEK_SET) == -1) {
		close(fd);
		sprintf(msgbuf, "lseek file: %s failed", fdir);
		cgiError(msgbuf);
		exit(1);
	}

	write(fd, &msgdir, sizeof(msgdir));

	close(fd);
	//upload file
	for (i=1;i<=9;i=i+1)//max 9 file
	{
	    sprintf(upload_name, "af%d", i);
	    cgiFormFileName(upload_name, upload_orig, sizeof(upload_orig));
		pt=strrchr(upload_orig,'.');
		if (pt==NULL) continue;
		str_lower(pt);//change to lower case
	    	sprintf(uploadfn, "%s/M.%d.A.%d%s", talk_path,(int) now,i,pt);
		//fprintf(MOUT,"Content-type: text/html\n\n");
		//fprintf(MOUT,"%s %s %s <br>\n\n",uploadfn ,upload_name,upload_orig);
	    //max size=1M
	    if (cgiFormFileSize( upload_name, &sizeP) != cgiFormSuccess || sizeP > 10000000)
		    continue;
	    if (cgiFormFileOpen( upload_name, &fptr)!= cgiFormSuccess) continue;
		//fprintf(MOUT,"OK!%s %s \n\n",uploadfn ,upload_name);
	   fp1 = fopen(uploadfn, "w");
	    while ( cgiFormFileRead( fptr, filebody, sizeof(filebody), &sizeP)==cgiFormSuccess)
	    {
	           fwrite(filebody,sizeP,1,fp1);
	    }
	     cgiFormFileClose( fptr); 
	     fclose(fp1);
	}//upload file

	/* write message body */
#ifdef GBCODE
	if ((fp = popen(msgfn, "w")) != NULL) {
#ifdef RREADONLY
	     for (i=0;i<strlen(msgbody);i=i+512)
	     {
		  strncpy(filebody,msgbody+i,512);
		  filebody[512]=0;
		  imgrep(filebody);
		  fputs(filebody,fp);  
	     }	
#else
   #ifdef READONLY
	     for (i=0;i<strlen(msgbody);i=i+512)
	     {
		  strncpy(filebody,msgbody+i,512);
		  filebody[512]=0;
		  imgrep(filebody);
		  fputs(filebody,fp);  
	     }	
   #else
		fputs(msgbody,fp);
   #endif     
#endif     
		pclose(fp);
	}
#else
	if ((fp = fopen(msgfn, "w")) != NULL) {
#ifdef RREADONLY
	     for (i=0;i<strlen(msgbody);i=i+512)
	     {
		  strncpy(filebody,msgbody+i,512);
		  filebody[512]=0;
		  imgrep(filebody);
		  fputs(filebody,fp);  
	     }	     
#else
   #ifdef READONLY
	     for (i=0;i<strlen(msgbody);i=i+512)
	     {
		  strncpy(filebody,msgbody+i,512);
		  filebody[512]=0;
		  imgrep(filebody);
		  fputs(filebody,fp);  
	     }	     
   #else
		fputs(msgbody,fp);
   #endif     
#endif     
		fclose(fp);
	}
#endif
	else {
		sprintf(msgbuf, "write file: %s failed", msgfn);
		cgiError(msgbuf);
		exit(1);
	}
	sprintf(homepage,"%s?user=%s&proc=list&bid=%d&msgno=%d",CGI_SCRIPT,user,bid,npost+1);
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
	fprintf(MOUT,"<script language=\"JavaScript\" type=\"text/javascript\">\n"
            "<!--\n"
        "window.location=\"%s\""
            "\n//-->\n</script>\n",homepage);
	return 0;
}

/*
 *---------------------------------------------------------------------
 *	Guestbook: Read
 *---------------------------------------------------------------------
 */

int gbook_read()
{
	int	fd, npost;
	char	subject[80] /*, msgfn[80]*/;
	//FILE	*fp;
#ifdef RREADONLY
	char buf[20];
	cgiFormStringNoNewlines("password",buf,16);
        if (strcmp(password,buf)) {
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
                fprintf(MOUT,"<h2>KX~I</h2>");
        fprintf(MOUT, "<center><a href=\"%s?user=%s&amp;bid=%d&amp;proc=list\">ЫB^De</a></center>", CGI_SCRIPT, user,bid);
                return 0;
        }

#endif

	if (cgiFormInteger("msgno", &msgno, 0) != cgiFormSuccess) {
		msgno=0;
	}

	if (stat(fdir, &st) >= 0) {
		npost = st.st_size / sizeof(struct msgDIR);
	} else {
		npost = 0;
	}

	if (msgno > npost||msgno==0 ) msgno = npost;//0 Latest message
	if (msgno < 0) msgno = 1;
	if ((fd = open(fdir, O_RDWR)) != -1) {
		lseek(fd, sizeof(msgdir) * (msgno - 1), SEEK_SET);
		read(fd, &msgdir, sizeof(msgdir));
		if (msgdir.item[9]<0) msgdir.item[9]=0;
		msgdir.item[9]++;
		lseek(fd, sizeof(msgdir) * (msgno - 1), SEEK_SET);
		write(fd, &msgdir, sizeof(msgdir));
		close(fd);
	} else {
		sprintf(msgbuf, "Can not open file: %s to read", fdir);
		cgiError(msgbuf);
		exit(1);
	}

	if (strncmp("^G", msgdir.subj, 6) != 0) {
		strcpy(subject, msgdir.subj);
	} else {
		strcpy(subject, msgdir.subj + 6);
	}
	
#ifdef GBCODE
	fprintf(MOUT,"Content-type: text/html\n\n");
#else
	cgiHeaderContentType("text/html");
#endif
	showout(READ_FILE);
	

	return 0;
}

int showout(char *filename)
{
    FILE *fptr;
    char buf[256],oneline[300];
    char *pt1,*pt2;
    int ptmode;
    struct stat sb;

/********* }YɡApGSYɡANۤvdefaultX ***/
     sprintf(buf, "%s/%s",gbook_path,filename);
   /*****ˬd O_@ɮ ******/
   if (!lstat(buf, &sb)) {
         //if ((sb.st_mode & 0777000) == S_IFLNK) {
         if ((sb.st_mode & 0777000) != S_IFREG) {
               fprintf(MOUT,"error: %s O@LinkIKKI\n",buf);
                                return (1);
                        }
   }
   else
   {
               fprintf(MOUT,"error: %s stat error!\n",buf);
                                return (1);
   }

   if( (fptr = fopen(buf,"r")) == NULL )
   {
    fprintf(MOUT,"%sɮ׶}ҿ~<br />",buf);
     return 0;
      
   }
   while(fgets(oneline, 300, fptr) != NULL)  
   {
      pt1=oneline;

#ifdef GBCODE
      if ((pt2=strstr(pt1,"charset=big5\">"))!=NULL)
      {
         sprintf(pt2,"charset=gb2312\">");
         
      }
#endif
      while ((pt2=strstr(pt1,"<!--$"))!=NULL)
      {
         *pt2=0;
         pt2=pt2+5;
         fprintf(MOUT,"%s", pt1);/* LXtokener */
         pt1=strstr(pt2,"-->");
         if (pt1==NULL) 
         {
            fprintf(MOUT,"榡ɿ~IP@椺䤣 -->");
            return 0;
         }
         *pt1=0;
         pt1=pt1+3;
         ptmode=atoi(pt2);
         SSI(ptmode);
     } //while <!--$
     fprintf(MOUT,"%s", pt1);
   } // while get oneline
      fclose(fptr);
   return 0;
}

/***** SSI for uX***/
int SSI(int ptmode)
{
   FILE *fp;
   char linebuf[1024],msgfn[128];
   int npost,msg1no;
   int i;
    switch (ptmode)
    {
      /*** LIST D ID ****/
      case 1 : if (strcmp(proc, GBOOK_SEARCH)!=0)
			g_list(0);
		else
			{
				g_search(0);
				strcpy(proc, GBOOK_LIST);
			}
			break;
      /**** CGIWr ***/
      case 2 : fprintf(MOUT,"%s",CGI_SCRIPT); break;
      /****峹D **/
      case 3 :  strcpy(linebuf,msgdir.subj);
		htmlrep(linebuf);
		fprintf(MOUT,"%s",linebuf); break;
      /*** 峹@ ***/
      case 4 :   strcpy(linebuf,msgdir.owner);
                htmlrep(linebuf);
		fprintf(MOUT, "%s", linebuf);break;
      /*** 峹ɶ ***/
      case 5 : fprintf(MOUT, "%s", ctime(&msgdir.ptime));break;
      /*** 峹e **/
      case 6:
        sprintf(msgfn, "%s/%s", talk_path, msgdir.fn); 
	    if ((fp = fopen(msgfn, "r")) != NULL) {
	        while (fgets(linebuf, 511, fp) != NULL)
		{
#ifndef READONLY
    #ifndef RREADONLY
			htmlrep(linebuf); //d <>&"
    #endif
#endif			
			//imgrep(linebuf); remove by tjm
			if (strrchr(linebuf,'\n')) //sb_
			    fprintf(MOUT, "%s<br />\n", linebuf);
			else
			    fprintf(MOUT, "%s", linebuf);
		}
	    fclose(fp);
	    }
	    else {
		    sprintf(msgbuf, "Can not open file: %s", msgfn);
		    cgiError(msgbuf);
		    exit(1);
	    }
	  break;
	  /**** EditɪwD ***/
  	case 7 : 
		strcpy(linebuf,msgsubj);
                htmlrep(linebuf);
		fprintf(MOUT, "%s", linebuf);break;
	  /**** Editɪwe ***/
  	case 8 : fprintf(MOUT, "%s", msgbody);break;
	  /**** Owner Email ***/
 	case 9 : strcpy(linebuf,msgdir.email);
                htmlrep(linebuf);
		fprintf(MOUT,"%s",linebuf); break;
	  /**** Owner URL ***/
	case 10 : fprintf(MOUT,"%s",msgdir.url); break;
	  /**** owner ﶵ ***/
	case 11 :
	case 12 :
	case 13 :
	case 14 :
	case 15 :
	case 16 :
	case 17 :
	case 18 :
	case 19 :
	case 20 : 
	        fprintf(MOUT,"%d",msgdir.item[ptmode-11]); break;
      /**** dҦID ***/
      case 21 : fprintf(MOUT,"%s",user); break;
      /**** `@Xhd ***/
      case 22 : 
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	fprintf(MOUT,"%d",npost); break;
      /**** ثeds ***/
      case 23 : 
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	cgiFormInteger("msgno", &msg1no, npost);
	fprintf(MOUT,"%d",msg1no); break;
	/***** U@ ******/
     case 24:
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	cgiFormInteger("msgno", &msg1no, npost);
	if (msg1no > MPP) {
		fprintf(MOUT, "<a href=\"%s?user=%s&amp;proc=%s&amp;bid=%d&amp;msgno=%d\">", 
		CGI_SCRIPT, user, proc,bid,msg1no - MPP);
	}
	else
		fprintf(MOUT, "<a href=\"%s?user=%s&amp;proc=%s&amp;bid=%d&amp;msgno=%d\">", 
		CGI_SCRIPT, user,proc,bid, msg1no);
	break;
     /**** W@ ****/
     case 25:
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	cgiFormInteger("msgno", &msg1no, npost);
	if (npost > (msg1no + MPP - 1)) {
		fprintf(MOUT, "<a href=\"%s?user=%s&amp;proc=%s&amp;bid=%d&amp;msgno=%d\">", 
		CGI_SCRIPT, user, proc,bid,msg1no + MPP);
	}
	else
		fprintf(MOUT, "<a href=\"%s?user=%s&amp;proc=%s&amp;bid=%d&amp;msgno=%d\">", 
		CGI_SCRIPT, user,proc, bid,npost);
	break;
	
	/**** ̫@ ****/
     case 26:
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
	if (npost<MPP)
		fprintf(MOUT, "<a href=\"%s?user=%s&amp;proc=%s&amp;bid=%d&amp;msgno=%d\">",
	CGI_SCRIPT,user,proc,bid,npost);
	else
		fprintf(MOUT, "<a href=\"%s?user=%s&amp;proc=%s&amp;bid=%d&amp;msgno=%d\">",
	CGI_SCRIPT,user,proc,bid,MPP);
	break;
     /***** EDITɻݭn\J@ø *****/
    case 27:
	if (reply) {
		fprintf(MOUT, "<input type=\"hidden\" name=\"type\" value=\"reply\" />");
		fprintf(MOUT, "<input type=\"hidden\" name=\"msgfn\" value=\"%s\" />", msgdir.fn);
		fprintf(MOUT, "<input type=\"hidden\" name=\"msgno\" value=\"%d\" />", msgno);
	}

	fprintf(MOUT, "<input type=\"hidden\" name=\"user\" value=\"%s\" />", user);
	fprintf(MOUT, "<input type=\"hidden\" name=\"proc\" value=\"post\" />");
	fprintf(MOUT, "<input type=\"hidden\" name=\"bid\" value=\"%d\" />", bid);
	break;
     /***** READɻݭn\J@ø ΨӦ^峹*****/
    case 28:
		fprintf(MOUT, "<form method=\"post\" action=\"%s\">", CGI_SCRIPT);
		fprintf(MOUT, "<input type=\"hidden\" name=\"user\" value=\"%s\" />", user);
		fprintf(MOUT, "<input type=\"hidden\" name=\"proc\" value=\"edit\" />");
		fprintf(MOUT, "<input type=\"hidden\" name=\"bid\" value=\"%d\" />", bid);
		fprintf(MOUT, "<input type=\"hidden\" name=\"msgno\" value=\"%d\" />", msgno);
		fprintf(MOUT, "<input type=\"hidden\" name=\"type\" value=\"reply\" />");
		fprintf(MOUT, "<input type=\"submit\" name=\"submit\" value=\"^峹\" /></form>");
		break;
	/***************ΨӲͤU@峹s *****/
    case 29:
		if (msgno > 1)  
			fprintf(MOUT, "%d",  msgno - 1);
		else
			fprintf(MOUT,"1");
		break;
	/********* ΨӲͤW@峹s ***/	
    case 30:
	if (stat(fdir, &st) >= 0) {
              npost = st.st_size / sizeof(struct msgDIR);
       	} else {
        npost = 0;
       	}
		if (msgno < npost) 
			fprintf(MOUT, "%d",msgno + 1);
		else
			fprintf(MOUT,"%d",npost);
		break;
	/********* ΨӲͤW@峹s ***/	
    case 31:
	fprintf(MOUT, "%d",msgno);
	break;
	/********* ΨӦCLXdD ***/	
    case 32:
	fprintf(MOUT, "%s",title);
	break;
	/********* ΨӦLXC峹g ***/	
    case 33:
	fprintf(MOUT, "%d",MPP);
	break;
	/********* ΨӦLX峹@IP ***/	
    case 34:
	fprintf(MOUT, "%s",msgdir.host);
	break;
	/***** ΨӰtα ****/
    case 35 : g_admin(0);
	      break;
    case 36:
        fprintf(MOUT, "%d", bid);
        break;
       /*****ثe峹CC *****/
    case 37:
        fprintf(MOUT, "%s", rowcolor[0]);
        break;
    case 38:
        fprintf(MOUT, "%s", rowcolor[1]);
        break;
       /*****w峹CC *****/
    case 39:
        fprintf(MOUT, "%s", ARRCOLOR1);
        break;
    case 40:
        fprintf(MOUT, "%s", ARRCOLOR2);
        break;
    /**** ޲z ﶵ ***/
        case 41 :
        case 42 :
        case 43 :
        case 44 :
        case 45 :
        case 46 :
        case 47 :
        case 48 :
        case 49 :
        case 50 :
                fprintf(MOUT,"%s",mainconf[ptmode-41]); break;
        case 51 : if (strcmp(proc, GBOOK_SEARCH)!=0)
			g_list(1);
		else
			{
				g_search(1);
				strcpy(proc, GBOOK_LIST);
			}
			break;
        case 52 : if (strcmp(proc, GBOOK_SEARCH)!=0)
			g_list(2);
		else
			{
				g_search(2);
				strcpy(proc, GBOOK_LIST);
			}
			break;
    	case 53 : g_admin(1); //FŦXз adm
	      	break;
	case 61:
	case 62:
	case 63:
	case 64:
	case 65:
	case 66:
	case 67:
	case 68:
	case 69:
		i=0;
		while (strlen(att_type[i])>0)
		{
        		sprintf(msgfn, "%s/%s.%d.%s", talk_path, msgdir.fn,ptmode-60,att_type[i]); 
	    	     if ((fp = fopen(msgfn, "r"))!=NULL) { 
			fprintf(MOUT,"<a href=\"%s?user=%s&amp;proc=attach&amp;bid=%d&amp;atype=%d&amp;file=%s.%d\" target=\"att\">%d</a> &nbsp;",
			        CGI_SCRIPT,user,bid,i,
			msgdir.fn,ptmode-60,ptmode-60);
			fclose(fp);
		      }
		     i=i+1;
		}

			break;
	case 71:
	case 72:
	case 73:
	case 74:
	case 75:
	case 76:
	case 77:
	case 78:
	case 79:
		i=0;
		while (strlen(att_type[i])>0)
		{
        		sprintf(msgfn, "%s/%s.%d.%s", talk_path, msgdir.fn,ptmode-70,att_type[i]); 
	    	     if ((fp = fopen(msgfn, "r"))!=NULL) { 
			fprintf(MOUT,"<img src=\"%s?user=%s&amp;proc=attach&amp;bid=%d&amp;atype=%d&amp;file=%s.%d\" align=\"left\" />",
			        CGI_SCRIPT,user,bid,i,
			msgdir.fn,ptmode-70);
			fclose(fp);
		      }
		     i=i+1;
		}

			break;
    }//switch
    return 0;
}

/* Cg@IIAHw */

int safewrite(int fd, char *buf, int size)
{
  int cc, sz = size, origsz = size;
  char *bp = buf;
  do
  {
    cc = write(fd, bp, sz);
    if ((cc < 0))
    {
      fprintf(MOUT,"safewrite failed!");
      return -1;
    }
    if (cc > 0)
    {
      bp += cc;
      sz -= cc;
    }
  } while (sz > 0);
  return origsz;
}



int delete_record(char *fpath, int size, int id)
{
  char abuf[512],msgfn[128];
  int fdr, fdw, fd;
  int count;
  nol my;
  struct msgDIR *recpt;

  sprintf(my.newfn, "%s.new", fpath);
  sprintf(my.oldfn, "%s.old", fpath);
  sprintf(my.lockfn, "%s.lock", fpath);

  if ((fd = open(my.lockfn, O_RDWR | O_CREAT | O_APPEND, 0644)) == -1)
    return -1;
  flock(fd, LOCK_EX);

  if ((fdr = open(fpath, O_RDONLY, 0)) == -1)
  {

    fprintf(MOUT,"delete_record failed!!! (open)");
    flock(fd, LOCK_UN);
    close(fd);
    return -1;
  }
  if ((fdw = open(my.newfn, O_WRONLY | O_CREAT | O_EXCL, 0644)) == -1)
  {
    flock(fd, LOCK_UN);

    fprintf(MOUT,"delete_record failed!!! (open tmpfile)");

    close(fd);
    close(fdr);
    return -1;
  }
  //fprintf(cgiOut,"%s,,%s,,%s",my.newfn,my.oldfn,my.lockfn);
  count = 1;
  while (read(fdr, abuf, size) == size)
  {
    if (id != count++ && (safewrite(fdw, abuf, size) == -1))
    {

      fprintf(MOUT,"delete_record failed!!! (safewrite)");
      unlink(my.newfn);
      close(fdr);
      close(fdw);
      flock(fd, LOCK_UN);
      close(fd);
      return -1;
    }
    else
    {
	if (id==count-1)
        {
	  recpt=abuf;
	  sprintf(msgfn, "/bin/rm -f %s/%s*", talk_path,recpt->fn);
	  system(msgfn); //kill with multimedia file
	  //fprintf(cgiOut,"||%s<br>||",msgfn);
	  //unlink(msgfn);//峹աI 
	}
    }
  }
  close(fdr);
  close(fdw);
  if (rename(fpath, my.oldfn) == -1 || rename(my.newfn, fpath) == -1)
  {
    fprintf(MOUT,"delete_record failed!!! (Rename)");
    flock(fd, LOCK_UN);
    close(fd);
    return -1;
  }
  flock(fd, LOCK_UN);
  close(fd);
  return 0;
}
/********************************
   ˬdɮפO_X{Ӧr
***********************************/
int is_file(char *filename,char *key)
{
 char linbuf[512],msgfn[128];  
 int flag=0;
 FILE *fp;
	sprintf(msgfn, "%s/%s", talk_path, filename);
	if ((fp = fopen(msgfn, "r")) != NULL) {
                while ((fgets(linbuf, 511, fp) != NULL)&&(flag==0))
			if (strstr(linbuf,key)) flag=1;
            fclose(fp);
            }
            else {
                    sprintf(msgbuf, "Can not open file: %s", filename);
                    cgiError(msgbuf);
                    exit(1);
            }
  return flag;

}

/*******󴫦r *******/
void imgrep(char *genbuf)
{ char *pt1,*pt2,result[800],buf[512];
  int i;
  FILE *fp;
 strncpy(result,genbuf,512);
 result[512]=0;
 pt1=result;
 *genbuf=0;
 while ((pt2=strstr(pt1,"[img$"))!=NULL)
 {
        *pt2=0;
	strcat(genbuf,pt1);
	pt2=pt2+5;
	i=0;
	while (strlen(att_type[i])>0)
	{
        	sprintf(buf, "%s/%s.%c.%s", talk_path, msgdir.fn,*pt2,att_type[i]); 
	    	if ((fp = fopen(buf, "r"))!=NULL) { 
			sprintf(buf,"<img src=\"%s?user=%s&amp;proc=attach&amp;bid=%d&amp;atype=%d&amp;file=%s.%c\" alt=\"attach\" />",
			        CGI_SCRIPT,user,bid,i,
			msgdir.fn,*pt2);
			strcat(genbuf,buf);
			fclose(fp);
		 }
		     i=i+1;
	}
	pt1=strstr(pt2,"]");
	if (pt1==NULL)
	{
	  	fprintf(MOUT,"榡ɿ~Iimg P@椺䤣 ]");
		return;
	}
	*pt1=0;
	pt1=pt1+1;
  }
  strcat(genbuf,pt1);
 strncpy(result,genbuf,799);
 result[799]=0;
 pt1=result;
 *genbuf=0;
 while ((pt2=strstr(pt1,"[link$"))!=NULL)
 {
        *pt2=0;
	strcat(genbuf,pt1);
	pt2=pt2+6;
	i=0;
	while (strlen(att_type[i])>0)
	{
        	sprintf(buf, "%s/%s.%c.%s", talk_path, msgdir.fn,*pt2,att_type[i]); 
	    	if ((fp = fopen(buf, "r"))!=NULL) { 
			sprintf(buf,"<a href=\"%s?user=%s&amp;proc=attach&amp;bid=%d&amp;atype=%d&amp;file=%s.%c\"  target=\"att\">s%c</a>",
			        CGI_SCRIPT,user,bid,i,
			msgdir.fn,*pt2,*pt2);
			strcat(genbuf,buf);
			fclose(fp);
		 }
		     i=i+1;
	}
	pt1=strstr(pt2,"]");
	if (pt1==NULL)
	{
	  	fprintf(MOUT,"榡ɿ~Ilink P@椺䤣 ]");
	        return ;
	}
	*pt1=0;
	pt1=pt1+1;
  }
  strcat(genbuf,pt1);
}
/*******󴫦r *******/
int htmlrep(char *genbuf)
{ char *pt1,result[512];
  int i,len;
  //return;
  strncpy(result,genbuf,511);
  result[511]=0;
  pt1=genbuf;
  len=strlen(result);
  for (i=0;i<len;i++)
  {
	if (result[i]=='>')
	{
		*pt1='&'; pt1++;
		*pt1='g'; pt1++;
		*pt1='t'; pt1++;
		*pt1=';'; pt1++;
	}
	else if (result[i]=='<')
	{
		*pt1='&'; pt1++;
		*pt1='l'; pt1++;
		*pt1='t'; pt1++;
		*pt1=';'; pt1++;
	}
	else if ((result[i]=='&')&&(result[i+1]!='#'))
	{
	     //²rɭԷ| &#35831; 
		*pt1='&'; pt1++;
		*pt1='a'; pt1++;
		*pt1='m'; pt1++;
		*pt1='p'; pt1++;
		*pt1=';'; pt1++;
	}
	else if (result[i]=='"')
	{
		*pt1='&'; pt1++;
		*pt1='q'; pt1++;
		*pt1='u'; pt1++;
		*pt1='o'; pt1++;
		*pt1='t'; pt1++;
		*pt1=';'; pt1++;
	}
	else 
	{
		*pt1=result[i];
		pt1++;
	}
  } //for i 
	*pt1=0; //close string
	return 0;
}
